#=
model;

param n;
param pi := 4*atan(1);

param a := 20.0;
param b :=  0.2;
param c := 2.0*pi;

var x{1..n} >= -15, <= 30;

minimize fun: -a*exp(-b*sqrt((1.0/n)*(sum{i in 1..n}x[i]^2)))-exp((1.0/n)*(sum{i in 1..n}cos(c*x[i])))+a+exp(1.0);


data;

param n := 2;
#param n := 5;
#param n := 10;
#param n := 20;
#param n := 50;
=#

function ackley(x::Array)
	a = 20
	b = 0.2
	c = 2*pi
	n = length(x)

	cx  = 0
	n2x = 0
	for i = 1:n
		cx = cx + cos(c*x[i])
		n2x = n2x + x[i]^2
	end

	f = -a*exp(-b*sqrt((1.0/n)*n2x))-exp((1.0/n)*cx)+a+exp(1.0)

	return f
end
