#=
param n;
param pi := 4*atan(1);

var x{1..n} >= -pi, <= pi;

minimize fun: sum{i in 1..n}(sin(x[i])*(sin(i*x[i]^2/pi))^20);

data;

param n := 2;
#param n := 5;
#param n := 10;
=#

function michalewics(x::Array)
	n = length(x)

	f = 0
	for i = 1:n
		f = f + (sin(x[i])*(sin(i*x[i]^2/pi))^20)
	end

	return f
end
