#=
model;

param n;

var x{1..n} >= -600, <= 600;

minimize fun: 418.9828873d0*n - sum{k in 1..n}x[k]*sin(sqrt(abs(x[k])));

data;

#param n := 2;
#param n := 5;
#param n := 10;
param n := 20;
#param n := 50;
=#

function schwefel(x::Array)
	n = length(x)

	a = 0
	for i = 1:n
		a = a + x[i]*sin(sqrt(abs(x[i])))
	end

	return 418.9828873*n - a
end
